# CfnCapacityReservation

Creates a new Capacity Reservation with the specified attributes.

For more information, see [Capacity Reservations](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/ec2-capacity-reservations.html) in the *Amazon EC2 User Guide* .

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnCapacityReservation
Implements: IInspectable, IEnvironmentAware, ICapacityReservationRef, IConstruct, IDependable

- CloudFormation: [`AWS::EC2::CapacityReservation`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-ec2-capacityreservation.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_ec2 as ec2 } from 'aws-cdk-lib';
const cfnCapacityReservation = new ec2.CfnCapacityReservation(this, 'MyCfnCapacityReservation', {
  instanceCount: 123,
  instancePlatform: 'instancePlatform',
  instanceType: 'instanceType',

  // the properties below are optional
  availabilityZone: 'availabilityZone',
  availabilityZoneId: 'availabilityZoneId',
  ebsOptimized: false,
  endDate: 'endDate',
  endDateType: 'endDateType',
  ephemeralStorage: false,
  instanceMatchCriteria: 'instanceMatchCriteria',
  outPostArn: 'outPostArn',
  placementGroupArn: 'placementGroupArn',
  tagSpecifications: [{
    resourceType: 'resourceType',
    tags: [{
      key: 'key',
      value: 'value',
    }],
  }],
  tenancy: 'tenancy',
  unusedReservationBillingOwnerId: 'unusedReservationBillingOwnerId',
});
```

## Initializer

```ts
new CfnCapacityReservation(scope: Construct, id: string, props: CfnCapacityReservationProps)
```

## Construct Props

- `availabilityZone`: string — The Availability Zone in which to create the Capacity Reservation.

- `availabilityZoneId`: string — The ID of the Availability Zone in which the capacity is reserved.

- `ebsOptimized`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the Capacity Reservation supports EBS-optimized instances.

  This optimization provides dedicated throughput to Amazon EBS and an optimized configuration stack to provide optimal I/O performance. This optimization isn't available with all instance types. Additional usage charges apply when using an EBS- optimized instance.

- `endDate`: string — The date and time at which the Capacity Reservation expires.

  When a Capacity Reservation expires, the reserved capacity is released and you can no longer launch instances into it. The Capacity Reservation's state changes to `expired` when it reaches its end date and time.

  You must provide an `EndDate` value if `EndDateType` is `limited` . Omit `EndDate` if `EndDateType` is `unlimited` .

  If the `EndDateType` is `limited` , the Capacity Reservation is cancelled within an hour from the specified time. For example, if you specify 5/31/2019, 13:30:55, the Capacity Reservation is guaranteed to end between 13:30:55 and 14:30:55 on 5/31/2019.

  If you are requesting a future-dated Capacity Reservation, you can't specify an end date and time that is within the commitment duration.

- `endDateType`: string — Indicates the way in which the Capacity Reservation ends.

  A Capacity Reservation can have one of the following end types:

  - `unlimited` - The Capacity Reservation remains active until you explicitly cancel it. Do not provide an `EndDate` if the `EndDateType` is `unlimited` .
  - `limited` - The Capacity Reservation expires automatically at a specified date and time. You must provide an `EndDate` value if the `EndDateType` value is `limited` .

- `ephemeralStorage`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — *Deprecated.*.

- `instanceCount`: number (required) — The number of instances for which to reserve capacity.

  > You can request future-dated Capacity Reservations for an instance count with a minimum of 32 vCPUs. For example, if you request a future-dated Capacity Reservation for `m5.xlarge` instances, you must request at least 8 instances ( *8 * m5.xlarge = 32 vCPUs* ).

  Valid range: 1 - 1000

- `instanceMatchCriteria`: string — Indicates the type of instance launches that the Capacity Reservation accepts. The options include:.

  - `open` - The Capacity Reservation automatically matches all instances that have matching attributes (instance type, platform, and Availability Zone). Instances that have matching attributes run in the Capacity Reservation automatically without specifying any additional parameters.
  - `targeted` - The Capacity Reservation only accepts instances that have matching attributes (instance type, platform, and Availability Zone), and explicitly target the Capacity Reservation. This ensures that only permitted instances can use the reserved capacity.

  > If you are requesting a future-dated Capacity Reservation, you must specify `targeted` .

  Default: `open`

- `instancePlatform`: string (required) — The type of operating system for which to reserve capacity.

- `instanceType`: string (required) — The instance type for which to reserve capacity.

  > You can request future-dated Capacity Reservations for instance types in the C, M, R, I, T, and G instance families only.

  For more information, see [Instance types](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/instance-types.html) in the *Amazon EC2 User Guide* .

- `outPostArn`: string — > Not supported for future-dated Capacity Reservations.

  The Amazon Resource Name (ARN) of the Outpost on which to create the Capacity Reservation.

- `placementGroupArn`: string — > Not supported for future-dated Capacity Reservations.

  The Amazon Resource Name (ARN) of the cluster placement group in which to create the Capacity Reservation. For more information, see [Capacity Reservations for cluster placement groups](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/cr-cpg.html) in the *Amazon EC2 User Guide* .

- `tagSpecifications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCapacityReservation.TagSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnCapacityReservation.TagSpecificationProperty.html)[] — The tags to apply to the Capacity Reservation during launch.

- `tenancy`: string — Indicates the tenancy of the Capacity Reservation. A Capacity Reservation can have one of the following tenancy settings:.

  - `default` - The Capacity Reservation is created on hardware that is shared with other AWS accounts .
  - `dedicated` - The Capacity Reservation is created on single-tenant hardware that is dedicated to a single AWS account .

- `unusedReservationBillingOwnerId`: string — The ID of the AWS account to which to assign billing of the unused capacity of the Capacity Reservation.

  A request will be sent to the specified account. That account must accept the request for the billing to be assigned to their account. For more information, see [Billing assignment for shared Amazon EC2 Capacity Reservations](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/assign-billing.html) .

  You can assign billing only for shared Capacity Reservations. To share a Capacity Reservation, you must add it to a resource share. For more information, see [AWS::RAM::ResourceShare](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-ram-resourceshare.html) .

## Properties

- `attrAvailabilityZone`: string — Returns the Availability Zone in which the capacity is reserved.

  For example: `us-east-1a` .

- `attrAvailableInstanceCount`: number — Returns the remaining capacity, which indicates the number of instances that can be launched in the Capacity Reservation.

  For example: `9` .

- `attrCapacityAllocationSet`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html)

- `attrCapacityReservationArn`: string — The Amazon Resource Name (ARN) of the Capacity Reservation.

- `attrCapacityReservationFleetId`: string — The ID of the Capacity Reservation Fleet to which the Capacity Reservation belongs.

  Only valid for Capacity Reservations that were created by a Capacity Reservation Fleet.

- `attrCommitmentInfo`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html)

- `attrCreateDate`: string — The date and time the Capacity Reservation was created.

- `attrDeliveryPreference`: string — The delivery method for a future-dated Capacity Reservation.

  `incremental` indicates that the requested capacity is delivered in addition to any running instances and reserved capacity that you have in your account at the requested date and time.

- `attrId`: string — The ID of the Capacity Reservation.

- `attrInstanceType`: string — Returns the type of instance for which the capacity is reserved.

  For example: `m4.large` .

- `attrOwnerId`: string — The ID of the AWS account that owns the Capacity Reservation.

- `attrReservationType`: string — The type of Capacity Reservation.

- `attrStartDate`: string — The date and time the Capacity Reservation was started.

- `attrState`: string — The current state of the Capacity Reservation. A Capacity Reservation can be in one of the following states:.

  - `active` - The capacity is available for use.
  - `expired` - The Capacity Reservation expired automatically at the date and time specified in your reservation request. The reserved capacity is no longer available for your use.
  - `cancelled` - The Capacity Reservation was canceled. The reserved capacity is no longer available for your use.
  - `pending` - The Capacity Reservation request was successful but the capacity provisioning is still pending.
  - `failed` - The Capacity Reservation request has failed. A request can fail due to request parameters that are not valid, capacity constraints, or instance limit constraints. You can view a failed request for 60 minutes.
  - `scheduled` - ( *Future-dated Capacity Reservations* ) The future-dated Capacity Reservation request was approved and the Capacity Reservation is scheduled for delivery on the requested start date.
  - `payment-pending` - ( *Capacity Blocks* ) The upfront payment has not been processed yet.
  - `payment-failed` - ( *Capacity Blocks* ) The upfront payment was not processed in the 12-hour time frame. Your Capacity Block was released.
  - `assessing` - ( *Future-dated Capacity Reservations* ) Amazon EC2 is assessing your request for a future-dated Capacity Reservation.
  - `delayed` - ( *Future-dated Capacity Reservations* ) Amazon EC2 encountered a delay in provisioning the requested future-dated Capacity Reservation. Amazon EC2 is unable to deliver the requested capacity by the requested start date and time.
  - `unsupported` - ( *Future-dated Capacity Reservations* ) Amazon EC2 can't support the future-dated Capacity Reservation request due to capacity constraints. You can view unsupported requests for 30 days. The Capacity Reservation will not be delivered.

- `attrTenancy`: string — Returns the tenancy of the Capacity Reservation.

  For example: `dedicated` .

- `attrTotalInstanceCount`: number — Returns the total number of instances for which the Capacity Reservation reserves capacity.

  For example: `15` .

- `availabilityZone`: string — The Availability Zone in which to create the Capacity Reservation.

- `availabilityZoneId`: string — The ID of the Availability Zone in which the capacity is reserved.

- `capacityReservationRef`: [CapacityReservationReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ec2.CapacityReservationReference.html) — A reference to a CapacityReservation resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `ebsOptimized`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — Indicates whether the Capacity Reservation supports EBS-optimized instances.

- `endDate`: string — The date and time at which the Capacity Reservation expires.

- `endDateType`: string — Indicates the way in which the Capacity Reservation ends.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `ephemeralStorage`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — *Deprecated.*.

- `instanceCount`: number — The number of instances for which to reserve capacity.

- `instanceMatchCriteria`: string — Indicates the type of instance launches that the Capacity Reservation accepts.

  The options include:.

- `instancePlatform`: string — The type of operating system for which to reserve capacity.

- `instanceType`: string — The instance type for which to reserve capacity.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `outPostArn`: string — > Not supported for future-dated Capacity Reservations.

- `placementGroupArn`: string — > Not supported for future-dated Capacity Reservations.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tagSpecifications`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnCapacityReservation.TagSpecificationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ec2.CfnCapacityReservation.TagSpecificationProperty.html)[] — The tags to apply to the Capacity Reservation during launch.

- `tenancy`: string — Indicates the tenancy of the Capacity Reservation.

  A Capacity Reservation can have one of the following tenancy settings:.

- `unusedReservationBillingOwnerId`: string — The ID of the AWS account to which to assign billing of the unused capacity of the Capacity Reservation.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForCapacityReservation(resource: ICapacityReservationRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromCapacityReservationArn(scope: Construct, id: string, arn: string): ICapacityReservationRef` (static) — Creates a new ICapacityReservationRef from an ARN.

- `fromCapacityReservationId(scope: Construct, id: string, capacityReservationId: string): ICapacityReservationRef` (static) — Creates a new ICapacityReservationRef from a capacityReservationId.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnCapacityReservation(x: any): boolean` (static) — Checks whether the given object is a CfnCapacityReservation.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
